Index: roard/req.c
===================================================================
--- roard/req.c	(revision 6052)
+++ roard/req.c	(revision 0)
@@ -1,114 +1,23 @@
 //req.c:
 
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
-
-/* ckport options:
- * massage <-> object converters:
- * ckport: ignore-symbol: roar_stream_s2m of target libroar0
- * ckport: ignore-symbol: roar_stream_m2s of target libroar0
- * ckport: ignore-symbol: roar_ctl_c2m of target libroar0
- * ckport: ignore-symbol: roar_ctl_ia2m of target libroar0
- * ckport: ignore-symbol: roar_ctl_m2f of target libroar0
- * Caps support:
- * ckport: ignore-symbol: roar_caps_from_msg of target libroar0
- * ckport: ignore-symbol: roar_caps_to_msg of target libroar0
- * Server info:
- * ckport: ignore-symbol: roar_server_info_to_mes of target libroar0
- * PASSFH:
- * ckport: ignore-symbol: roar_socket_recv_fh of target libroar0
- * AUTH:
- * ckport: ignore-symbol: roar_auth_from_mes of target libroar0
- * ckport: ignore-symbol: roar_auth_to_mes of target libroar0
- * Events:
- * ckport: ignore-symbol: roar_event_from_blob of target libroar0
- * Filter:
- * ckport: ignore-symbol: roar_filter_match of target libroar0
- */
-
 #include "roard.h"
 
-// include for uname() used by req_on_server_info()
-#ifdef ROAR_HAVE_UNAME
-#include <sys/utsname.h>
-#endif
-
-static void * _dataspace(struct roar_message * mes, char ** data, uint32_t flags[2], size_t len) {
- if ( len <= LIBROAR_BUFFER_MSGDATA )
-  return mes->data;
-
- if ( *data != NULL )
-  roar_mm_free(*data);
-
- *data = roar_mm_malloc(len);
-
- ROAR_DBG("_dataspace(mes=%p, data=%p, flags=%p, len=%llu): *data=%p", mes, data, flags, (long long unsigned int)len, *data);
-
- if ( *data == NULL )
-  return NULL;
-
- flags[1] |= COMMAND_FLAG_OUT_LONGDATA;
-
- return *data;
-}
-
-int req_on_noop        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- (void)client, (void)data, (void)flags;
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 0;
- return 0;
-}
-
-int req_on_quit        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- (void)client, (void)data;
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 0;
- flags[1] |= COMMAND_FLAG_OUT_DELETE;
- return 0;
-}
-
-int req_on_identify    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- struct roar_client_server * cs;
- struct roar_client        * c;
+int req_on_noop        (int client, struct roar_message * mes, char * data) {
+ mes->cmd     = ROAR_CMD_OK;
+ mes->datalen = 0;
+ return 0;
+}
+
+int req_on_identify    (int client, struct roar_message * mes, char * data) {
+ struct roar_client * c;
  int max_len;
 
- (void)data, (void)flags;
-
  if ( mes->datalen < 1 )
   return -1;
 
- clients_get_server(client, &cs);
-
- c = ROAR_CLIENT(cs);
+ clients_get(client, &c);
 
  if ( mes->data[0] == 1 ) {
-  if ( c->pid == -1 ) {
-   c->pid       = ROAR_NET2HOST32(*(uint32_t*)((mes->data)+1));
-   ROAR_DBG("req_on_identify(): new PID: c->pid = %i", c->pid);
-  }
-
-  ROAR_DBG("req_on_identify(): final PID: c->pid = %i", c->pid);
+  c->pid       = ROAR_NET2HOST32(*(uint32_t*)((mes->data)+1));
 
   max_len = (mes->datalen - 5) < (ROAR_BUFFER_NAME-1) ? (mes->datalen - 5) : (ROAR_BUFFER_NAME-1);
@@ -117,11 +26,5 @@
   c->name[max_len] = 0;
 
-  // we set the acclevel to IDENTED here.
-  // if it is alreay > IDENTED we reset it anyway
-  // as potential auth relevent data changed.
-  cs->acclev = ACCLEV_IDENTED;
-
   mes->cmd     = ROAR_CMD_OK;
-  mes->pos     = g_pos;
   mes->datalen = 0;
 
@@ -134,111 +37,24 @@
 }
 
-int req_on_auth        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- struct roar_error_frame   error_frame;
- void                    * error_data;
- struct roar_message       error_mes;
- struct roar_client_server * cs;
- struct roar_auth_message    authmes;
- int next = -1;
- int ret;
-
- (void)flags;
-
- clients_get_server(client, &cs);
-
+int req_on_auth        (int client, struct roar_message * mes, char * data) {
  // TODO: add code to support some auth.
-
- if ( roar_auth_from_mes(&authmes, mes, *data) == -1 )
-  return -1;
-
- ROAR_INFO("req_on_auth(client=%i,...): authtype=%s(%i), len=%llu bytes", ROAR_DBG_INFO_VERBOSE,
-                           client, roar_autht2str(authmes.type), authmes.type, (long long unsigned int)authmes.len);
-
- ROAR_DBG("req_on_auth(client=%i,...): CALL auth_client_ckeck(cs=%p, &authmes=%p, &next=%p)", client, cs, &authmes, &next);
- ret = auth_client_ckeck(cs, &authmes, &next);
- ROAR_DBG("req_on_auth(client=%i,...): RET %i // next=%s(%i)", client, ret, roar_autht2str(next), next);
-
- if ( ret != 1 ) {
-  ROAR_DBG("req_on_auth(client=%i,...) = ?", client);
-
-  if ( next != -1 ) {
-   ROAR_DBG("req_on_auth(client=%i,...) = ?", client);
-   memset(&authmes, 0, sizeof(authmes));
-
-   authmes.type = next;
-
-   if ( roar_auth_to_mes(&error_mes, NULL, &authmes) == -1 )
-    return -1;
-
-   ROAR_DBG("req_on_auth(client=%i,...) = ?", client);
-
-   if ( roar_err_init(&error_frame) == -1 )
-    return -1;
-
-   ROAR_DBG("req_on_auth(client=%i,...) = ?", client);
-
-   error_frame.ra_errno = ROAR_ERROR_PERM;
-   error_frame.datalen  = error_mes.datalen;
-
-   error_data   = roar_err_buildmsg(mes, NULL, &error_frame);
-   ROAR_DBG("req_on_auth(client=%i,...): error_data=%p", client, error_data);
-
-   memcpy(error_data, error_mes.data, error_mes.datalen);
-
-   mes->cmd     = ROAR_CMD_ERROR;
-   mes->pos     = g_pos;
-
-   ROAR_DBG("req_on_auth(client=%i,...): mes=%p{.datalen=%i}", client, mes, (int)mes->datalen);
-   ROAR_DBG("req_on_auth(client=%i,...) = 0 // cmd=ERROR", client);
-   return 0;
-  }
-
-  ROAR_DBG("req_on_auth(client=%i,...) = 0", client);
-  return -1;
- }
-
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 0;
-
- ROAR_DBG("req_on_auth(client=%i,...) = 0", client);
- return 0;
-}
-
-
-int req_on_whoami      (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- (void)data, (void)flags;
-
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 1;
- mes->data[0] = client;
- return 0;
-}
-
-
-int req_on_new_stream  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
+ mes->cmd     = ROAR_CMD_OK;
+ mes->datalen = 0;
+ return 0;
+}
+
+
+int req_on_new_stream  (int client, struct roar_message * mes, char * data) {
  int stream;
- struct roar_stream_server * ss;
- struct roar_stream        * s;
- struct roar_stream * source_stream;
- struct roar_audio_info * info;
- struct roar_audio_info * source_info;
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): creating stream...", client);
+ struct roar_stream * s;
+
  if ((stream = streams_new()) == -1 )
   return -1;
 
- ROAR_DBG("req_on_new_stream(client=%i, ...): stream=%i", client, stream);
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): getting stream...", client);
- if ( streams_get(stream, &ss) == -1 ) {
+ if ( streams_get(stream, (struct roar_stream_server **)&s) == -1 ) {
   streams_delete(stream);
   return -1;
  }
 
- s = ROAR_STREAM(ss);
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): set client of stream...", client);
  if ( client_stream_add(client, stream) == -1 ) {
   streams_delete(stream);
@@ -246,5 +62,4 @@
  }
 
- ROAR_DBG("req_on_new_stream(client=%i, ...): loading stream from message...", client);
  if ( roar_stream_m2s(s, mes) == -1 ) {
   streams_delete(stream);
@@ -252,119 +67,4 @@
  }
 
- ROAR_DBG("req_on_new_stream(client=%i, ...): setting id and codec of stream...", client);
- ROAR_STREAM(s)->id = stream; // roar_stream_m2s() resets this
- ROAR_STREAM_SERVER(s)->codec_orgi = ROAR_STREAM(s)->info.codec;
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): setting direction stream...", client);
- // int streams_set_dir    (int id, int dir, int defaults)
- if ( streams_set_dir(stream, ROAR_STREAM(s)->dir, 1) == -1 ) {
-  streams_delete(stream);
-  return -1;
- }
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): checking mixer settings...", client);
- if ( mes->stream != -1 && mes->stream != ss->mixer_stream ) {
-  streams_delete(stream);
-  return -1;
- }
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): setting up direction specific stream settings...", client);
- switch (ROAR_STREAM(s)->dir) {
-  case ROAR_DIR_LIGHT_IN:
-  case ROAR_DIR_LIGHT_OUT:
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-    info = &(ROAR_STREAM(s)->info);
-
-    info->channels = 0;
-    info->bits     = 0;
-    info->rate     = 0;
-#else
-    streams_delete(stream);
-    return -1;
-#endif
-
-   break;
-  case ROAR_DIR_MIDI_IN:
-  case ROAR_DIR_MIDI_OUT:
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-    info = &(ROAR_STREAM(s)->info);
-
-    info->channels = ROAR_MIDI_CHANNELS_DEFAULT;
-    info->bits     = ROAR_MIDI_BITS;
-    info->rate     = 0;
-#else
-    streams_delete(stream);
-    return -1;
-#endif
-
-   break;
-
-  case ROAR_DIR_RAW_IN:
-#ifndef ROAR_WITHOUT_DCOMP_RAW
-    if ( ROAR_STREAM(s)->pos_rel_id == -1     ||
-         ROAR_STREAM(s)->pos_rel_id == stream ||
-         streams_get_dir(ROAR_STREAM(s)->pos_rel_id) != ROAR_DIR_RAW_OUT
-       ) {
-     ROAR_STREAM(s)->pos_rel_id = -1; // force this here as it will try to delete itself while deleting
-                                      // in case rel_id == stream
-     streams_delete(stream);
-     return -1;
-    }
-#else
-  case ROAR_DIR_RAW_OUT:
-    streams_delete(stream);
-    return -1;
-#endif
-
-   break;
-  case ROAR_DIR_THRU:
-
-    if ( ROAR_STREAM(s)->pos_rel_id == -1 || ROAR_STREAM(s)->pos_rel_id == stream ) {
-     ROAR_STREAM(s)->pos_rel_id = -1; // force this here as it will try to delete itself while deleting
-                                      // in case rel_id == stream
-     streams_delete(stream);
-     return -1;
-    }
-
-    if ( streams_get_clientobj(ROAR_STREAM(s)->pos_rel_id, &source_stream) == -1 ) {
-     streams_delete(stream);
-     return -1;
-    }
-
-    info        = &(ROAR_STREAM(s)->info);
-    source_info = &(ROAR_STREAM(source_stream)->info);
-
-    info->channels = source_info->channels;
-    info->bits     = source_info->bits;
-    info->rate     = source_info->rate;
-    info->codec    = source_info->codec;
-    ROAR_STREAM_SERVER(s)->codec_orgi = ROAR_STREAM_SERVER(source_stream)->codec_orgi;
-
-   break;
-  case ROAR_DIR_FILTER:
-    info        = &(ROAR_STREAM(s)->info);
-
-    if ( ROAR_STREAM(s)->pos_rel_id == -1 ) {
-     source_info = g_sa;
-    } else {
-     if ( streams_get_clientobj(ROAR_STREAM(s)->pos_rel_id, &source_stream) == -1 ) {
-      streams_delete(stream);
-      return -1;
-     }
-     source_info = &(ROAR_STREAM(source_stream)->info);
-    }
-
-    if ( info->channels != source_info->channels || info->bits != source_info->bits ||
-         info->codec    != source_info->codec    || info->rate != source_info->rate ) {
-     // the stream parameters don't match the one of the stream being filtered.
-     // -> delete and reject the stream.
-     streams_delete(stream);
-     return -1;
-    }
-   break;
- }
-
- ROAR_DBG("req_on_new_stream(client=%i, ...): returning (OK, stream=%i)...", client, stream);
-
  mes->cmd     = ROAR_CMD_OK;
  mes->stream  = stream;
@@ -374,680 +74,73 @@
 }
 
-int req_on_exec_stream (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- struct roar_message    m;
- struct roar_client   * c;
- struct roar_connection con;
- int16_t * d = (int16_t*)mes->data;
- int sock;
- int i;
+int req_on_exec_stream (int client, struct roar_message * mes, char * data) {
  int r;
 
- ROAR_DBG("req_on_exec_stream(client=%i, mes={stream=%i,...},...): execing stream", client, mes->stream);
-
-
- if ( mes->stream != -1 ) {
-  if ( streams_is_ready(mes->stream) ) {
-   flags[1] |= COMMAND_FLAG_OUT_CLOSECON;
-  } else {
-   if ( (r = client_stream_exec(client, mes->stream)) == -1 )
-    return -1;
-  }
-
-  ROAR_DBG("req_on_exec_stream(client=%i, mes={stream=%i,...},...): returning (OK)...", client, mes->stream);
-  mes->cmd     = ROAR_CMD_OK;
-  mes->datalen = 0;
-  return 0;
- }
-
- ROAR_DBG("req_on_exec_stream(client=%i,...): non stream exec", client);
-
- if ( mes->datalen < 4*2 )
-  return -1;
-
- ROAR_DBG("req_on_exec_stream(client=%i,...) = ?", client);
-
- for (i = 0; i < 4; i++) {
-  d[i] = ROAR_NET2HOST16(d[i]);
- }
-
- if ( d[0] != 0 ) // version
-  return -1;
-
- if ( d[1] != 0 ) // flags
-  return -1;
-
- if ( clients_get_protohandle(d[2]) == NULL )
-  return -1;
-
- ROAR_DBG("req_on_exec_stream(client=%i,...) = ?", client);
-
- memset(&m, 0, sizeof(m));
-
- m.cmd = ROAR_CMD_OK;
-
- flags[1] |= COMMAND_FLAG_OUT_NOSEND;
-
- c = ROAR_CLIENT(g_clients[client]);
-
- sock = c->fh;
-
- if ( sock == -1 )
-  return -1;
-
- ROAR_DBG("req_on_exec_stream(client=%i,...) = ?", client);
-
- roar_connect_fh(&con, sock);
-
- roar_send_message(&con, &m, NULL);
-
- clients_set_fh(client, -1);
- clients_delete(client);
-
- ROAR_DBG("req_on_exec_stream(client=%i,...): calling clients_new_from_fh(): sock=%i, d={?, ?, %i, %i}", client, sock, (int)d[2], (int)d[3]);
- if ( clients_new_from_fh(sock, d[2], d[3], 1) == -1 ) {
-  close(sock);
- }
-
- ROAR_DBG("req_on_exec_stream(client=%i,...) = 0", client);
-
- return 0;
-}
-
-int req_on_con_stream  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- char   host[80] = {0};
- int    port = 0;
- int    type = ROAR_SOCKET_TYPE_NONE;
- int    transport_protocol = ROAR_PROTO_NONE;
- int    fh;
- int    len;
-
- if ( mes->datalen < 4 ) {
-  roar_err_set(ROAR_ERROR_BADMSG);
-  return -1;
- }
-
- if ( mes->datalen > 80 ) { // we do not support long messages here
-  roar_err_set(ROAR_ERROR_MSGSIZE);
-  return -1;
- }
-
- switch (*(mes->data)) {
-  case 0: // version 0 packet:
-    type = (unsigned)mes->data[1];
-    port = ROAR_NET2HOST16(((uint16_t*)mes->data)[1]);
-
-    len = mes->datalen - 4;
-
-    strncpy(host, &(mes->data[4]), len);
-    host[len] = 0;
-   break;
-  default:
-    roar_err_set(ROAR_ERROR_NSVERSION);
-    return -1;
-   break;
- }
-
- if ( type > ROAR_SOCKET_TYPE_MAX ) {
-  roar_err_set(ROAR_ERROR_NOENT);
-  return -1;
- }
-
- switch (type) {
-  case ROAR_SOCKET_TYPE_NONE:
-  case ROAR_SOCKET_TYPE_FORK:
-  case ROAR_SOCKET_TYPE_GENSTR:
-    roar_err_set(ROAR_ERROR_INVAL);
-    return -1;
-   break;
-  case ROAR_SOCKET_TYPE_FILE:
-    roar_err_set(ROAR_ERROR_PERM);
-    return -1;
-   break;
-  default:
-    // pass.
-   break;
- }
-
- switch (transport_protocol) {
-  case ROAR_PROTO_NONE:
-  case ROAR_PROTO_SIMPLE: // same a NONE, plain data over socket. diffrence is only in setup.
-    transport_protocol = ROAR_PROTO_NONE;
-   break;
-  default:
-    roar_err_set(ROAR_ERROR_NOSYS);
-    return -1;
-   break;
- }
-
- ROAR_DBG("req_on_con_stream(*): CONNECT(type=%i, host='%s', port=%i)", type, host, port);
-
- roar_libroar_nowarn();
- fh = roar_socket_open(ROAR_SOCKET_MODE_CONNECT, type, host, port);
- roar_libroar_warn();
-
- if ( fh == -1 )
-  return -1;
-
- if ( client_stream_set_fh(client, mes->stream, fh) == -1 ) {
-  close(fh);
-  return 1;
- }
-
- mes->datalen = 0;
- mes->cmd     = ROAR_CMD_OK;
-
- return 0;
-}
-
-int req_on_passfh      (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- int sock = clients_get_fh(client);
- int16_t * d = (int16_t*)mes->data;
- struct roard_listen * lsock;
- int listening;
- int fh;
- int i;
-
- ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...) = ?", client, mes->stream);
-
- if ( (fh = roar_socket_recv_fh(sock, NULL, NULL)) == -1 ) {
-  ROAR_WARN("req_on_passfh(client=%i, mes={stream=%i,...},...): was unabled to get filehandle from remote end. bad.", client, mes->stream);
-  ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): returning (ERROR)...", client, mes->stream);
-  return -1;
- }
-
- ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): fh=%i", client, mes->stream, fh);
-
- if ( mes->stream != -1 ) { // stream pass:
-  ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): This is a stream passfh", client, mes->stream);
-
-  if ( client_stream_set_fh(client, mes->stream, fh) == -1 ) {
-   close(fh);
-   ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): returning (ERROR)...", client, mes->stream);
-   return -1;
-  }
-
-  ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): returning (OK)...", client, mes->stream);
-
-  mes->datalen = 0;
-  mes->cmd     = ROAR_CMD_OK;
-
-  return 0;
- }
-
-// non-stream pass:
-
- ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): This is a client passfh", client, mes->stream);
-
-/*
- 0: Version,   16
- 1: Flags,     16
- 2: Protocol,  16
- 3: Byteorder, 16
- Options...
-*/
-
- if ( mes->datalen < 4*2 )
-  return -1;
-
- for (i = 0; i < 4; i++) {
-  d[i] = ROAR_NET2HOST16(d[i]);
- }
-
- if ( d[0] != 0 ) // version
-  return -1;
-
- listening = d[1] & ROAR_CLIENTPASS_FLAG_LISTEN;
-
- if ( listening )
-  d[1] -= ROAR_CLIENTPASS_FLAG_LISTEN;
-
- if ( d[1] != 0 ) // flags
-  return -1;
-
- if ( listening ) {
-  if ( get_listen(&lsock, NULL) == -1 ) {
-   close(fh);
-   return -1;
-  }
-
-  roar_vio_open_fh_socket(&(lsock->sock), fh);
-  lsock->used   = 1;
-  lsock->proto  = d[2];
- } else {
-  if ( clients_new_from_fh(fh, d[2], d[3], 1) == -1 )
-   return -1;
- }
-
- ROAR_DBG("req_on_passfh(client=%i, mes={stream=%i,...},...): returning (OK)...", client, mes->stream);
-
- mes->datalen = 0;
- mes->cmd     = ROAR_CMD_OK;
-
- return 0;
-}
-
-#ifdef ROAR_SUPPORT_META
-int req_on_set_meta    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- int type;
- int mode;
- int namelen, vallen;
- char   val[255+1];
- char   name[ROAR_META_MAX_NAMELEN+1];
-
- if ( mes->datalen < 3 )
-  return -1;
-
- if ( mes->data[0] != 0 ) // version
-  return -1;
-
- mode = (unsigned) mes->data[1];
- type = (unsigned) mes->data[2];
-
- ROAR_DBG("req_on_set_meta(*): mode=%i, type=%i", mode, type);
-
- if ( mode == ROAR_META_MODE_CLEAR ) {
-  stream_meta_clear(mes->stream);
-  mes->datalen = 0;
-  mes->cmd     = ROAR_CMD_OK;
-  return 0;
- } else if ( mode == ROAR_META_MODE_DELETE ) { // unsuppoerted at the moment
-  return -1;
- } else if ( mode == ROAR_META_MODE_FINALIZE ) {
-  stream_meta_finalize(mes->stream);
-  mes->datalen = 0;
-  mes->cmd     = ROAR_CMD_OK;
-  return 0;
- } else if ( mode == ROAR_META_MODE_SET || mode == ROAR_META_MODE_ADD ) {
-  if ( mes->datalen < 5 )
-   return -1;
-
-  namelen = (unsigned) mes->data[3];
-  vallen  = (unsigned) mes->data[4];
-
-  ROAR_DBG("req_on_set_meta(*): namelen=%i, vallen=%i", namelen, vallen);
-
-  if ( mes->datalen < (5 + namelen + vallen) )
-   return -1;
-
-  if ( namelen > ROAR_META_MAX_NAMELEN )
-   return -1;
-
-  strncpy(name, &(mes->data[5]), namelen);
-  name[namelen] = 0;
-
-  if ( vallen > 255 )
-   return -1;
-
-  strncpy(val, &(mes->data[5+namelen]), vallen);
-  val[vallen] = 0;
-
-  if ( mode == ROAR_META_MODE_SET ) {
-   if ( stream_meta_set(mes->stream, type, name, val) == -1 )
-    return -1;
-  } else {
-   if ( stream_meta_add(mes->stream, type, name, val) == -1 )
-    return -1;
-  }
-
-  mes->datalen = 0;
-  mes->cmd     = ROAR_CMD_OK;
-  return 0;
- } else { // unknown mode!
-  return -1;
- }
-
+ if ( (r = client_stream_exec(client, mes->stream)) == -1 )
+  return -1;
+
+ mes->cmd     = ROAR_CMD_OK;
+ mes->datalen = 0;
+
+ return 0;
+}
+
+
+int req_on_set_meta    (int client, struct roar_message * mes, char * data) {
  return -1;
 }
 
-int req_on_get_meta    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- int vallen;
- int type;
- char val[LIBROAR_BUFFER_MSGDATA-1];
-
+
+int req_on_server_oinfo    (int client, struct roar_message * mes, char * data) {
+ struct roar_stream s;
+//ROAR_DIR_OUTPUT
+
+ s.dir           = ROAR_DIR_OUTPUT;
+ s.pos_rel_id    = -1;
+ s.info.rate     = g_sa->rate;
+ s.info.bits     = g_sa->bits;
+ s.info.channels = g_sa->channels;
+ s.info.codec    = g_sa->codec;
+
+ if ( roar_stream_s2m(&s, mes) == -1 )
+  return -1;
+
+ mes->cmd = ROAR_CMD_OK;
+
+ return 0;
+}
+
+
+int req_on_get_standby (int client, struct roar_message * mes, char * data) {
+ mes->cmd = ROAR_CMD_OK;
+ mes->datalen = 2;
+
+ *((uint16_t*)mes->data) = ROAR_HOST2NET16((unsigned) g_standby);
+
+ return 0;
+}
+
+int req_on_set_standby (int client, struct roar_message * mes, char * data) {
  if ( mes->datalen != 2 )
   return -1;
 
- if ( mes->data[0] != 0 ) // version
-  return -1;
-
- type = (unsigned) mes->data[1];
-
- if ( stream_meta_get(mes->stream, type, NULL, val, LIBROAR_BUFFER_MSGDATA-2) == -1 )
-  return -1;
-
- vallen = strlen(val);
-
- mes->cmd     = ROAR_CMD_OK;
- mes->datalen = 2 + vallen;
-
- mes->data[0] = 0;
- mes->data[1] = (unsigned char) vallen;
-
- val[vallen] = 0;
-
- strncpy(&(mes->data[2]), val, vallen+1);
-
- return 0;
-}
-
-int req_on_list_meta   (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- int i;
- int len = 0;
- int types[ROAR_META_MAX_PER_STREAM];
-
- if ( mes->datalen != 1 )
-  return -1;
-
- if ( mes->data[0] != 0 ) // version
-  return -1;
-
- if ( (len = stream_meta_list(mes->stream, types, ROAR_META_MAX_PER_STREAM)) == -1 )
-  return -1;
-
- mes->cmd     = ROAR_CMD_OK;
- mes->datalen = 1 + len;
- mes->data[0] = 0;
-
- for (i = 0; i < len; i++)
-  mes->data[i+1] = types[i];
-
- return 0;
-}
-#endif
-
-int req_on_gettimeofday (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- struct roar_time curtime;
- uint64_t * d64 = (uint64_t *)mes->data;
-
- ROAR_DBG("req_on_gettimeofday(client=%i, mes=%p, data=%p, flags=%p) = ?", client, mes, data, flags);
-
- if ( *data != NULL ) {
-  return -1;
- }
-
- ROAR_DBG("req_on_gettimeofday(client=%i, mes=%p, data=%p, flags=%p) = ?", client, mes, data, flags);
-
- if ( mes->datalen && mes->datalen < 8 ) {
-  return -1;
- }
-
- ROAR_DBG("req_on_gettimeofday(client=%i, mes=%p, data=%p, flags=%p) = ?", client, mes, data, flags);
-
- if ( mes->datalen >= 8 ) {
-  if ( *d64 != 0 ) {
-   return -1;
-  }
- }
-
- ROAR_DBG("req_on_gettimeofday(client=%i, mes=%p, data=%p, flags=%p) = ?", client, mes, data, flags);
-
- if ( roar_clock_gettime(&curtime, ROAR_CLOCK_REALTIME) == -1 )
-  return -1;
-
- if ( roar_time_to_msg(mes, &curtime) == -1 )
-  return -1;
-
- mes->cmd = ROAR_CMD_OK;
-
- ROAR_DBG("req_on_gettimeofday(client=%i, mes=%p, data=%p, flags=%p) = ?", client, mes, data, flags);
-
- return 0;
-}
-
-int req_on_server_info (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
-#ifdef ROAR_HAVE_UNAME
- struct utsname utsname;
-#endif
-#ifdef ROAR_HAVE_GETVERSIONEX
- OSVERSIONINFO osinfo;
- char buf_release[80];
-#endif
- struct roar_server_info info;
- uint16_t * d16;
-#ifdef ROAR_HAVE_GETHOSTID
- long hostid;
- char hostidbuf[64];
-#endif
-
- if ( mes->datalen != 4 )
-  return -1;
-
- d16 = (uint16_t*)mes->data;
-
- // check version.
- if ( ROAR_NET2HOST16(d16[0]) != 0 )
-  return -1;
-
- switch (ROAR_NET2HOST16(d16[1])) {
-  case ROAR_IT_SERVER:
-   memset(&info, 0, sizeof(info));
-
-   // the following if is optimized out by compiler.
-   if ( ROAR_VERSION_DISTRIBUTION_STRING[0] == 0 ) {
-    info.version = "roard/" ROAR_VERSION_STRING " <" ROAR_DEV_VENDOR_STRING ">";
-   } else {
-    info.version = "roard/" ROAR_VERSION_STRING " <" ROAR_DEV_VENDOR_STRING "> (" ROAR_VERSION_DISTRIBUTION_STRING ")";
-   }
-
-   info.build   = ROAR_BUILD_STAMP;
-   info.license = ROAR_LICENSE_GPLv3_0;
-
-#ifdef ROAR_HAVE_GETHOSTID
-   hostid = gethostid();
-   snprintf(hostidbuf, sizeof(hostidbuf), sizeof(long) == 8 ? "0x%.16lx" : "0x%.8lx", hostid);
-   info.hostid = hostidbuf;
-#endif
-
-   if ( !!strcmp(g_config->location, CONF_DEF_STRING) )
-    info.location = g_config->location;
-
-   if ( !!strcmp(g_config->description, CONF_DEF_STRING) )
-    info.description = g_config->description;
-
-   info.contact = g_config->contact;
-   info.serial  = g_config->serial;
-   info.uiurl   = g_config->uiurl;
-
-#ifdef ROAR_HAVE_UNAME
-   if ( uname(&utsname) == 0 ) {
-    roar_random_salt_nonce(&utsname, sizeof(utsname));
-    info.un.sysname  = utsname.sysname;
-    info.un.release  = utsname.release;
-    info.un.nodename = utsname.nodename;
-    info.un.machine  = utsname.machine;
-   }
-#endif
-#ifdef ROAR_HAVE_GETVERSIONEX
-   osinfo.dwOSVersionInfoSize = sizeof(osinfo);
-   if ( GetVersionEx(&osinfo) ) {
-    info.un.sysname = "Windows";
-    snprintf(buf_release, sizeof(buf_release), "%i.%i.%i",
-               (int)osinfo.dwMajorVersion, (int)osinfo.dwMinorVersion, (int)osinfo.dwBuildNumber);
-    buf_release[sizeof(buf_release)-1] = 0;
-    info.un.release = buf_release;
-   }
-#endif
-
-   *data = NULL;
-
-   if ( roar_server_info_to_mes(mes, &info, (void**)data) == -1 )
-    return -1;
-
-   if ( *data != NULL )
-    flags[1] |= COMMAND_FLAG_OUT_LONGDATA;
-  break;
-  default: /* unknown request */
-    return -1;
-   break;
- }
-
- mes->cmd = ROAR_CMD_OK;
-
- return 0;
-}
-
-int req_on_server_oinfo    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- struct roar_stream s;
- int dir = ROAR_DIR_PLAY;
- int subsys;
-//ROAR_DIR_OUTPUT
-
- if ( mes->datalen != 0 ) {
-  if ( mes->datalen != 2 )
-   return -1;
-
-  if ( mes->data[0] != 0 )
-   return -1;
-
-  dir = mes->data[1];
- }
-
- subsys = streams_dir2subsys(dir);
-
- memset(&s, 0, sizeof(struct roar_stream));
-
- s.dir           = ROAR_DIR_MIXING;
- s.pos_rel_id    = -1;
-
- switch (subsys) {
-  case ROAR_SUBSYS_WAVEFORM:
-    s.info.rate     = g_sa->rate;
-    s.info.bits     = g_sa->bits;
-    s.info.channels = g_sa->channels;
-    s.info.codec    = g_sa->codec;
-    s.pos           = g_pos;
-   break;
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-  case ROAR_SUBSYS_MIDI:
-   break;
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-  case ROAR_SUBSYS_LIGHT:
-    s.info.rate     = ROAR_OUTPUT_CFREQ;
-    s.info.bits     = ROAR_LIGHT_BITS;
-    s.info.channels = g_light_state.channels;
-   break;
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_RAW
-  case ROAR_SUBSYS_RAW:
-    // no need to set anything here.
-   break;
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_RDTCS
-  case ROAR_SUBSYS_RDTCS:
-    s.info.rate     = ROAR_OUTPUT_CFREQ;
-    s.info.bits     = ROAR_RDTCS_BITS;
-    s.info.channels = ROAR_RDTCS_CHANNELS;
-    s.info.codec    = ROAR_RDTCS_CODEC;
-   break;
-#endif
-  default:
-    return -1;
-   break;
- }
-
- if ( roar_stream_s2m(&s, mes) == -1 )
-  return -1;
-
- mes->cmd = ROAR_CMD_OK;
-
- return 0;
-}
-
-int req_on_caps        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- struct roar_caps caps;
- struct roar_stds * stds;
- size_t i;
-
- if ( roar_caps_from_msg(&caps, mes, *data) == -1 )
-  return -1;
-
- // handle the data from the caps command here...
-
- if ( !(caps.flags & ROAR_CF_REQUEST) ) {
-  mes->cmd = ROAR_CMD_OK;
-  mes->datalen = 0;
-  return 0;
- }
-
- mes->datalen = 0;
-
- switch (caps.type) {
-  case ROAR_CT_STANDARDS:
-    if ( (stds = roar_stds_new(g_caps_stds.stds_len)) == NULL )
-     return -1;
-
-    for ( i = 0; i < stds->stds_len; i++) {
-     stds->stds[i] = ROAR_HOST2NET32(g_caps_stds.stds[i]);
-    }
-
-    caps.data = stds->stds;
-    caps.len  = stds->stds_len * 4;
-    // TODO: add support for **data.
-    if ( roar_caps_to_msg(mes, &caps, NULL) == -1 ) {
-     roar_stds_free(stds);
-     return -1;
-    }
-    roar_stds_free(stds);
-   break;
-  default:
-    return -1;
-   break;
- }
-
- mes->cmd = ROAR_CMD_OK;
-
- return 0;
-}
-
-int req_on_get_standby (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- uint16_t * d16 = (uint16_t*)mes->data;
-
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 2;
-
- *d16 = ROAR_HOST2NET16((unsigned) g_standby);
-
- return 0;
-}
-
-int req_on_set_standby (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- uint16_t * d16 = (uint16_t*)mes->data;
-
- if ( mes->datalen != 2 )
-  return -1;
-
- g_standby = ROAR_NET2HOST16(*d16);
-
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 0;
-
- return 0;
-}
-
-int req_on_exit      (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
- int term = 0;
-
- if ( mes->datalen == 1 )
-  term = mes->data[0];
-
- mes->cmd     = ROAR_CMD_OK;
- mes->pos     = g_pos;
- mes->datalen = 0;
-
- ROAR_DBG("req_on_exit(*): term=%i", term);
-
- if ( term ) {
-  cleanup_listen_socket(1);
- } else {
-  alive = 0;
- }
-
- return 0;
-}
-
-int req_on_list_clients(int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
+ g_standby = ROAR_NET2HOST16(*((uint16_t*)mes->data));
+
+ mes->cmd     = ROAR_CMD_OK;
+ mes->datalen = 0;
+
+ return 0;
+}
+
+int req_on_exit      (int client, struct roar_message * mes, char * data) {
+ mes->cmd     = ROAR_CMD_OK;
+ mes->datalen = 0;
+
+ alive = 0;
+
+ return 0;
+}
+
+int req_on_list_clients(int client, struct roar_message * mes, char * data) {
  unsigned char filter, cmp;
  uint32_t id;
@@ -1074,34 +167,21 @@
  return 0;
 }
-int req_on_list_streams(int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
+int req_on_list_streams(int client, struct roar_message * mes, char * data) {
  unsigned char filter, cmp;
  uint32_t id;
  int streams[ROAR_STREAMS_MAX];
  int i, c = 0;
- int match;
 
  if ( roar_ctl_m2f(mes, &filter, &cmp, &id) == -1 )
   return -1;
 
+ // TODO: add code to support filter
+ if ( filter != ROAR_CTL_FILTER_ANY )
+  return -1;
+
  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-  if ( g_streams[i] == NULL )
-   continue;
-
-  match = 0;
-
-  switch (filter) {
-   case ROAR_CTL_FILTER_ANY:
-     match = 1;
-    break;
-   case ROAR_CTL_FILTER_DIR:
-     match = roar_filter_match(cmp, id, ROAR_STREAM(g_streams[i])->dir);
-    break;
-   default: // unsupported filter...
-     return -1;
-    break;
+  if ( g_streams[i] != NULL ) {
+   streams[c++] = i;
   }
-
-  if ( match )
-   streams[c++] = i;
  }
 
@@ -1113,15 +193,10 @@
 }
 
-int req_on_get_client  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
+int req_on_get_client  (int client, struct roar_message * mes, char * data) {
  struct roar_client * c;
- int ret;
 
  if ( mes->datalen != 1 )
   return -1;
 
- if ( *data != NULL )
-  roar_mm_free(*data);
- *data = NULL;
-
  if ( clients_get(mes->data[0], &c) == -1 )
   return -1;
@@ -1129,13 +204,8 @@
  mes->cmd = ROAR_CMD_OK;
 
- ret = roar_ctl_c2m2(mes, c, (void**)data);
-
- if ( *data != NULL )
-  flags[1] |= COMMAND_FLAG_OUT_LONGDATA;
-
- return ret;
-}
-
-int req_on_get_stream  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
+ return roar_ctl_c2m(mes, c);
+}
+
+int req_on_get_stream  (int client, struct roar_message * mes, char * data) {
  struct roar_stream_server * s;
 
